local ADDON = ...

local prgname = "|cffffd200gmLoot|r"
local string_format = string.format

GMLOOT = GMLOOT or {}
GMLOOT["COINS"] = 	GMLOOT["COINS"] 	or true
GMLOOT["QUEST"] = 	GMLOOT["QUEST"] 	or true


local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("gmLoot", {
	type = "data source",
	icon = "Interface\\Icons\\INV_Misc_QuestionMark.blp",
	text = "None"
})


local function UpdateLDB()

		local autoloot = GetCVar("autoLootDefault")

		dataobj.icon = "Interface\\Icons\\INV_Misc_Gear_08.blp"

		if autoloot ==  "1" 	then 
			dataobj.text = "auto" 
		else
			dataobj.text = "man" 
		end
		
end

local frame1 = CreateFrame("Frame")
frame1:RegisterEvent('CVAR_UPDATE')
frame1:RegisterEvent("PLAYER_ENTERING_WORLD")
frame1:SetScript("OnEvent", function(self, event, ...)
			UpdateLDB()
end
)

local frame2 = CreateFrame("Frame")
frame2:RegisterEvent('LOOT_OPENED')
frame2:SetScript("OnEvent", function(self, event, ...)

		if  GetCVar("autoLootDefault") ==  "1" then return end	
		
		-- code adapted and simplified by semiautolooter --
		local loot_count = GetNumLootItems()
		for slot = 1, loot_count do
			local _,_,_,_,locked,isQuestItem = GetLootSlotInfo(slot)
			if isQuestItem == true and not locked and GMLOOT["QUEST"] == true then
				LootSlot(slot);
			elseif GetLootSlotType(slot) == LOOT_SLOT_MONEY and not locked and GMLOOT["COINS"] == true then
				LootSlot(slot);
			end
		end	
		-- end --
end
)

local frame3 = CreateFrame("FRAME")
frame3:RegisterEvent("ADDON_LOADED")	
frame3:SetScript("OnEvent", function(self, event, arg1, ...)	
	
	if event == "ADDON_LOADED" and arg1 == "gmLoot" then		

		local summary = ""


		if  GetCVar("autoLootDefault") ==  "1" then
			summary = summary .. "[loot AUTO] "
		else
			summary = summary .. "[loot MANUAL] "
			
			if GMLOOT["COIN"] == false then	
				summary = summary .. "[autoloot money no] "
			else
				summary = summary .. "[autoloot money yes] "
			end

			if GMLOOT["QUEST"] == false then	
				summary = summary .. "[autoloot quest no] "
			else
				summary = summary .. "[autoloot quest yes] "
			end
		
		end
		
		print(string_format("%s: %s" , prgname, summary))
		self:UnregisterEvent("ADDON_LOADED")		
	end	
end)	


dataobj.OnClick = function(self, button)  

	if InCombatLockdown() then 
		return 
	end

	if button == "RightButton" then 
			if GMLOOT["QUEST"] == true then 
				GMLOOT["QUEST"] = false 
			else 
				GMLOOT["QUEST"] = true
			end		
	end

	if button == "MiddleButton" then 
			if GMLOOT["COINS"] == true then 
				GMLOOT["COINS"] = false 
			else 
				GMLOOT["COINS"] = true
			end		
	end	
	
	
	if button == "LeftButton" then
		if GetCVar("autoLootDefault") == "1" then 
			SetCVar( "autoLootDefault", "0", true )
		else
			SetCVar( "autoLootDefault", "1", true )
		end
		UpdateLDB()	
	 end

end

function dataobj:OnEnter()
	
	if InCombatLockdown() then 
		return 
	end
	
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
	GameTooltip:ClearLines()
	dataobj.OnTooltipShow(GameTooltip)
	GameTooltip:Show()
	
end

function dataobj:OnTooltipShow()

	GameTooltip:AddLine(ADDON)
	GameTooltip:AddLine(" ")
	
	if GetCVar("autoLootDefault") == "1" then 
		GameTooltip:AddDoubleLine("Loot mode", "auto", 1,1,1,0,1,0)
	else
		GameTooltip:AddDoubleLine("Loot mode", "manual", 1,1,1,1,0,0)
	end	

	if GMLOOT["COINS"] == true then 
		GameTooltip:AddDoubleLine("AutoLoot coins", "YES", 1,1,1,0,1,0)
	else
		GameTooltip:AddDoubleLine("AutoLoot coins", "NO", 1,1,1,1,0,0)
	end
	
	if GMLOOT["QUEST"] == true then 
		GameTooltip:AddDoubleLine("AutoLoot quest items", "YES", 1,1,1,0,1,0)
	else
		GameTooltip:AddDoubleLine("AutoLoot quest items", "NO", 1,1,1,1,0,0)
	end
	
	GameTooltip:AddLine(" ")
	GameTooltip:AddDoubleLine("Left Click", "Toggle Loot Mode")
	GameTooltip:AddDoubleLine("Middle Click", "Toggle AutoLoot coins")
	GameTooltip:AddDoubleLine("Right Click", "Toggle AutoLoot quest items")

end

function dataobj:OnLeave()
	GameTooltip:Hide()
end


